﻿// The code demonstrated here is used to monitor specific Tags from the selected Service.
// The AddTags method and ValuesChangedAll Event is all that is needed to monitor Tags.
// You can also monitor DirectOPC items directly from OPC Servers without having to create OPC Systems.NET Tags.
// Use the OPC Excel Tag Browser to get the proper format of the DirectOPC interface.

//INSTANT C# NOTE: Formerly VB project-level imports:
using System;
using System.Collections;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;

namespace Example
{
	public class FormReadValues : System.Windows.Forms.Form
	{
		private bool m_Closing;
		// A Queue or Hashtable is recommended to receieve your values so they can be processed on a seperate thread.
		// You can also process data directly from the ValuesChangedAll Event, but keep in mind other values will be buffered until you release the Event.
		private Queue m_DataValuesQueue = new Queue(); // This Queue demonstrates a technique for processing a lot of data.
		private Hashtable m_DataValuesHashtable = new Hashtable(); // This hashtable will contain the values for each Tag to access whenever you like.
		internal System.Windows.Forms.Timer TimerToProcessValues;
		internal System.Windows.Forms.Button ButtonSyncRead;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.Button ButtonReadOPCItems;
		internal OPCSystemsDataConnector.OPCSystemsData OpcSystemsData;
		private bool m_InProcessValues = false;

#region  Windows Form Designer generated code 

		public FormReadValues() : base()
		{

			//This call is required by the Windows Form Designer.
			InitializeComponent();

			//Add any initialization after the InitializeComponent() call

		}

		//Form overrides dispose to clean up the component list.
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		//Required by the Windows Form Designer
		private System.ComponentModel.IContainer components;

		//NOTE: The following procedure is required by the Windows Form Designer
		//It can be modified using the Windows Form Designer.  
		//Do not modify it using the code editor.
		internal System.Windows.Forms.Button ButtonAddTags;
		internal System.Windows.Forms.Button ButtonRemoveTags;
		internal System.Windows.Forms.Button ButtonAddRamp2;
		internal System.Windows.Forms.Button ButtonRemveRamp2;
		internal System.Windows.Forms.Button ButtonRemoveRandom2;
		internal System.Windows.Forms.Button ButtonAddRandom2;
		internal System.Windows.Forms.Button ButtonRemoveSine2;
		internal System.Windows.Forms.Button ButtonAddSine2;
		internal System.Windows.Forms.TextBox TextBoxValues;
		[System.Diagnostics.DebuggerStepThrough()]
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(FormReadValues));
			this.ButtonAddTags = new System.Windows.Forms.Button();
			this.ButtonRemoveTags = new System.Windows.Forms.Button();
			this.ButtonAddRamp2 = new System.Windows.Forms.Button();
			this.ButtonRemveRamp2 = new System.Windows.Forms.Button();
			this.ButtonRemoveRandom2 = new System.Windows.Forms.Button();
			this.ButtonAddRandom2 = new System.Windows.Forms.Button();
			this.ButtonRemoveSine2 = new System.Windows.Forms.Button();
			this.ButtonAddSine2 = new System.Windows.Forms.Button();
			this.TextBoxValues = new System.Windows.Forms.TextBox();
			this.TimerToProcessValues = new System.Windows.Forms.Timer(this.components);
			this.ButtonSyncRead = new System.Windows.Forms.Button();
			this.Label1 = new System.Windows.Forms.Label();
			this.Label2 = new System.Windows.Forms.Label();
			this.ButtonReadOPCItems = new System.Windows.Forms.Button();
			this.OpcSystemsData = new OPCSystemsDataConnector.OPCSystemsData(this.components);
			this.SuspendLayout();
			//
			//ButtonAddTags
			//
			this.ButtonAddTags.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, Convert.ToByte(0));
			this.ButtonAddTags.Location = new System.Drawing.Point(15, 24);
			this.ButtonAddTags.Name = "ButtonAddTags";
			this.ButtonAddTags.Size = new System.Drawing.Size(269, 40);
			this.ButtonAddTags.TabIndex = 1;
			this.ButtonAddTags.Text = "Add Ramp, Random, and Sine";
			this.ButtonAddTags.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			//
			//ButtonRemoveTags
			//
			this.ButtonRemoveTags.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, Convert.ToByte(0));
			this.ButtonRemoveTags.Location = new System.Drawing.Point(15, 66);
			this.ButtonRemoveTags.Name = "ButtonRemoveTags";
			this.ButtonRemoveTags.Size = new System.Drawing.Size(269, 40);
			this.ButtonRemoveTags.TabIndex = 2;
			this.ButtonRemoveTags.Text = "Remove Ramp, Random, and Sine";
			this.ButtonRemoveTags.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			//
			//ButtonAddRamp2
			//
			this.ButtonAddRamp2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, Convert.ToByte(0));
			this.ButtonAddRamp2.Location = new System.Drawing.Point(15, 115);
			this.ButtonAddRamp2.Name = "ButtonAddRamp2";
			this.ButtonAddRamp2.Size = new System.Drawing.Size(269, 40);
			this.ButtonAddRamp2.TabIndex = 3;
			this.ButtonAddRamp2.Text = "Add Ramp2";
			this.ButtonAddRamp2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			//
			//ButtonRemveRamp2
			//
			this.ButtonRemveRamp2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, Convert.ToByte(0));
			this.ButtonRemveRamp2.Location = new System.Drawing.Point(15, 156);
			this.ButtonRemveRamp2.Name = "ButtonRemveRamp2";
			this.ButtonRemveRamp2.Size = new System.Drawing.Size(269, 40);
			this.ButtonRemveRamp2.TabIndex = 4;
			this.ButtonRemveRamp2.Text = "Remove Ramp2";
			this.ButtonRemveRamp2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			//
			//ButtonRemoveRandom2
			//
			this.ButtonRemoveRandom2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, Convert.ToByte(0));
			this.ButtonRemoveRandom2.Location = new System.Drawing.Point(15, 249);
			this.ButtonRemoveRandom2.Name = "ButtonRemoveRandom2";
			this.ButtonRemoveRandom2.Size = new System.Drawing.Size(269, 40);
			this.ButtonRemoveRandom2.TabIndex = 6;
			this.ButtonRemoveRandom2.Text = "Remove Random2";
			this.ButtonRemoveRandom2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			//
			//ButtonAddRandom2
			//
			this.ButtonAddRandom2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, Convert.ToByte(0));
			this.ButtonAddRandom2.Location = new System.Drawing.Point(15, 207);
			this.ButtonAddRandom2.Name = "ButtonAddRandom2";
			this.ButtonAddRandom2.Size = new System.Drawing.Size(269, 40);
			this.ButtonAddRandom2.TabIndex = 5;
			this.ButtonAddRandom2.Text = "Add Random2";
			this.ButtonAddRandom2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			//
			//ButtonRemoveSine2
			//
			this.ButtonRemoveSine2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, Convert.ToByte(0));
			this.ButtonRemoveSine2.Location = new System.Drawing.Point(15, 341);
			this.ButtonRemoveSine2.Name = "ButtonRemoveSine2";
			this.ButtonRemoveSine2.Size = new System.Drawing.Size(269, 40);
			this.ButtonRemoveSine2.TabIndex = 8;
			this.ButtonRemoveSine2.Text = "Remove Sine2";
			this.ButtonRemoveSine2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			//
			//ButtonAddSine2
			//
			this.ButtonAddSine2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, Convert.ToByte(0));
			this.ButtonAddSine2.Location = new System.Drawing.Point(15, 299);
			this.ButtonAddSine2.Name = "ButtonAddSine2";
			this.ButtonAddSine2.Size = new System.Drawing.Size(269, 40);
			this.ButtonAddSine2.TabIndex = 7;
			this.ButtonAddSine2.Text = "Add Sine2";
			this.ButtonAddSine2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			//
			//TextBoxValues
			//
			this.TextBoxValues.Anchor = (System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) | System.Windows.Forms.AnchorStyles.Left) | System.Windows.Forms.AnchorStyles.Right);
			this.TextBoxValues.Location = new System.Drawing.Point(310, 16);
			this.TextBoxValues.Multiline = true;
			this.TextBoxValues.Name = "TextBoxValues";
			this.TextBoxValues.Size = new System.Drawing.Size(458, 510);
			this.TextBoxValues.TabIndex = 9;
			//
			//TimerToProcessValues
			//
			this.TimerToProcessValues.Enabled = true;
			//
			//ButtonSyncRead
			//
			this.ButtonSyncRead.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, Convert.ToByte(0));
			this.ButtonSyncRead.Location = new System.Drawing.Point(15, 414);
			this.ButtonSyncRead.Name = "ButtonSyncRead";
			this.ButtonSyncRead.Size = new System.Drawing.Size(269, 40);
			this.ButtonSyncRead.TabIndex = 54;
			this.ButtonSyncRead.Text = "Sync Read Tags";
			this.ButtonSyncRead.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			//
			//Label1
			//
			this.Label1.AutoSize = true;
			this.Label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, (System.Drawing.FontStyle)(System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Underline), System.Drawing.GraphicsUnit.Point, Convert.ToByte(0));
			this.Label1.Location = new System.Drawing.Point(8, 5);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(172, 16);
			this.Label1.TabIndex = 55;
			this.Label1.Text = "Asynchronous  Reading";
			//
			//Label2
			//
			this.Label2.AutoSize = true;
			this.Label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, (System.Drawing.FontStyle)(System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Underline), System.Drawing.GraphicsUnit.Point, Convert.ToByte(0));
			this.Label2.Location = new System.Drawing.Point(8, 392);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(164, 16);
			this.Label2.TabIndex = 56;
			this.Label2.Text = "Synchronous  Reading";
			//
			//ButtonReadOPCItems
			//
			this.ButtonReadOPCItems.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, Convert.ToByte(0));
			this.ButtonReadOPCItems.Location = new System.Drawing.Point(15, 460);
			this.ButtonReadOPCItems.Name = "ButtonReadOPCItems";
			this.ButtonReadOPCItems.Size = new System.Drawing.Size(269, 40);
			this.ButtonReadOPCItems.TabIndex = 57;
			this.ButtonReadOPCItems.Text = "Sync Read OPC Items";
			this.ButtonReadOPCItems.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			//
			//OpcSystemsData
			//
			//
			//FormReadValues
			//
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(792, 548);
			this.Controls.Add(this.ButtonReadOPCItems);
			this.Controls.Add(this.Label2);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.ButtonSyncRead);
			this.Controls.Add(this.TextBoxValues);
			this.Controls.Add(this.ButtonRemoveSine2);
			this.Controls.Add(this.ButtonAddSine2);
			this.Controls.Add(this.ButtonRemoveRandom2);
			this.Controls.Add(this.ButtonAddRandom2);
			this.Controls.Add(this.ButtonRemveRamp2);
			this.Controls.Add(this.ButtonAddRamp2);
			this.Controls.Add(this.ButtonRemoveTags);
			this.Controls.Add(this.ButtonAddTags);
			this.DoubleBuffered = true;
			this.Icon = (System.Drawing.Icon)resources.GetObject("$this.Icon");
			this.Name = "FormReadValues";
			this.Text = "Read Values";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.ResumeLayout(false);
			this.PerformLayout();

//INSTANT C# NOTE: Converted design-time event handler wireups:
			ButtonAddTags.Click += new System.EventHandler(ButtonAddTags_Click);
			ButtonRemoveTags.Click += new System.EventHandler(ButtonRemoveTags_Click);
			ButtonAddRamp2.Click += new System.EventHandler(ButtonAddRamp2_Click);
			ButtonRemveRamp2.Click += new System.EventHandler(ButtonRemveRamp2_Click);
			ButtonAddRandom2.Click += new System.EventHandler(ButtonAddRandom2_Click);
			ButtonRemoveRandom2.Click += new System.EventHandler(ButtonRemoveRandom2_Click);
			ButtonAddSine2.Click += new System.EventHandler(ButtonAddSine2_Click);
			ButtonRemoveSine2.Click += new System.EventHandler(ButtonRemoveSine2_Click);
			base.Closing += new System.ComponentModel.CancelEventHandler(FormReadValues_Closing);
			//OpcSystemsData.ValuesChangedAll += new System.EventHandler(OpcSystemsData_ValuesChangedAll);
            OpcSystemsData.ValuesChangedAll += new OPCSystemsDataConnector.OPCSystemsData.ValuesChangedAllEventHandler(OpcSystemsData_ValuesChangedAll);
            
			base.Load += new System.EventHandler(FormReadValues_Load);
			TimerToProcessValues.Tick += new System.EventHandler(TimerToProcessValues_Tick);
			ButtonSyncRead.Click += new System.EventHandler(ButtonSyncRead_Click);
			ButtonReadOPCItems.Click += new System.EventHandler(ButtonReadOPCItems_Click);
		}

#endregion

		private Int32 m_NumberOfValues;

		// Continuous monitoring method.
		// Call AddTags
		// Receive the values as they changed in the ValuesChangedAll event.
		private void ButtonAddTags_Click(object sender, System.EventArgs e)
		{
			string[] Tags = new string[3];
			Tags[0] = "Ramp.Value";
			Tags[1] = "Sine.Value";
			Tags[2] = "Random.Value";
			OpcSystemsData.AddTags(Tags);
		}

		private void ButtonRemoveTags_Click(object sender, System.EventArgs e)
		{
			string[] Tags = new string[3];
			Tags[0] = "Ramp.Value";
			Tags[1] = "Sine.Value";
			Tags[2] = "Random.Value";
			OpcSystemsData.RemoveTags(Tags);
		}

		private void ButtonAddRamp2_Click(object sender, System.EventArgs e)
		{
			OpcSystemsData.AddTag("Ramp2.Value");
		}

		private void ButtonRemveRamp2_Click(object sender, System.EventArgs e)
		{
			OpcSystemsData.RemoveTag("Ramp2.Value");
		}

		private void ButtonAddRandom2_Click(object sender, System.EventArgs e)
		{
			OpcSystemsData.AddTag("Random2.Value");
		}

		private void ButtonRemoveRandom2_Click(object sender, System.EventArgs e)
		{
			OpcSystemsData.RemoveTag("Random2.Value");
		}

		private void ButtonAddSine2_Click(object sender, System.EventArgs e)
		{
			OpcSystemsData.AddTag("Sine2.Value");
		}

		private void ButtonRemoveSine2_Click(object sender, System.EventArgs e)
		{
			OpcSystemsData.RemoveTag("Sine2.Value");
		}

		private void FormReadValues_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			m_Closing = true;

			while (m_InProcessValues)
			{
				Application.DoEvents();
			}
		}

		// This event fires when the values of the Tags change.
		private void OpcSystemsData_ValuesChangedAll(string[] Tags, object[] Values, bool[] Qualities, DateTime[] TimeStamps)
		{
			// High speed version with a lot of data values changing
			lock (m_DataValuesQueue.SyncRoot)
			{
				m_DataValuesQueue.Enqueue(new ClassTagValues(Tags, Values, Qualities, TimeStamps));
			}

			// You can use the values directly here within the data event, but the example shown above with a Queue will work best with thousands of tags updating evey second.
			//' Simple version of just obtaining the tag value you are interested in.
			//Dim TagIndex As Int32
			//Dim NumberOfTagValues As Int32 = Tags.GetLength(0)
			//For TagIndex = 0 To NumberOfTagValues - 1
			//    Select Case Tags(TagIndex)
			//        Case "Ramp.Value"
			//            If Qualities(TagIndex) Then
			//                ' The value of Ramp.Value is contained in Values(TagIndex)
			//            Else
			//                ' The value of Ramp.Value is bad
			//            End If
			//    End Select
			//Next
		}

		private void FormReadValues_Load(object sender, System.EventArgs e)
		{
			this.SetStyle(ControlStyles.AllPaintingInWmPaint | ControlStyles.UserPaint | ControlStyles.OptimizedDoubleBuffer, true);
		}

		// This is executed from the timer.  Notice that the values from the Queue are pushed to a local array to be processed without the Queue being locked so it can receive additional data.
		// Once you have the data on your own thread you can do anything you like.  Here this example updates the TextBox and updates a Hashtable as well.
		private void TimerToProcessValues_Tick(object sender, System.EventArgs e)
		{
			if (m_InProcessValues)
			{
				return;
			}
			if (m_Closing)
			{
				return;
			}
			m_InProcessValues = true;

			ClassTagValues[] arrTagValues = new ClassTagValues[0];
			Int32 numberOfTagValues = 0;
			lock (m_DataValuesQueue.SyncRoot)
			{
				if (m_DataValuesQueue.Count < 1)
				{
					m_InProcessValues = false;
					return; // There is nothing to do
				}
				numberOfTagValues = m_DataValuesQueue.Count;
				arrTagValues = new Example.ClassTagValues[numberOfTagValues];
				m_DataValuesQueue.CopyTo(arrTagValues, 0);
				m_DataValuesQueue.Clear();
			}

			Int32 allTagValuesIndex = 0;
			ClassTagValues allTagValues = null;

			string[] tagNames = null;
			object[] tagValues = null;
			bool[] tagQualities = null;
			DateTime[] tagTimeStamps = null;
			Int32 tagIndex = 0;
			Int32 numberOfTags = 0;

			System.Text.StringBuilder UpdateString = new System.Text.StringBuilder();
			double ValueDouble = 0;
			int ValueInteger = 0;
			bool ValueBoolean = false;
			string ValueString = null;
			ValueDouble = 0;
			ValueInteger = 0;
			ValueBoolean = false;
			ValueString = "";

			for (allTagValuesIndex = 0; allTagValuesIndex < numberOfTagValues; allTagValuesIndex++)
			{
				// Obtain arrays of tags and values from the tag values class previously stored in the OpcSystemsData_ValuesChangedAll event
				allTagValues = arrTagValues[allTagValuesIndex];
				tagNames = allTagValues.TagNames;
				tagValues = allTagValues.Values;
				tagQualities = allTagValues.Qualities;
				tagTimeStamps = allTagValues.TimeStamps;
				numberOfTags = tagNames.GetLength(0);
				lock (m_DataValuesHashtable.SyncRoot)
				{
					for (tagIndex = 0; tagIndex < numberOfTags; tagIndex++)
					{
						try
						{
							UpdateString.Append(tagTimeStamps[tagIndex].ToString("HH:mm:ss.fff") + " ");
						}
						catch (Exception ex)
						{
							UpdateString.Append("Unknown Time ");
						}
						UpdateString.Append(tagNames[tagIndex] + " = ");

						if (tagQualities[tagIndex]) // The Tag quality is good
						{
							// Store value to a hashtable so you can access it from your own routines
							if (m_DataValuesHashtable.Contains(tagNames[tagIndex]))
							{
								m_DataValuesHashtable[tagNames[tagIndex]] = tagValues[tagIndex];
							}
							else
							{
								m_DataValuesHashtable.Add(tagNames[tagIndex], tagValues[tagIndex]);
							}
							try
							{
								if (object.ReferenceEquals(tagValues[tagIndex].GetType(), typeof(double)))
								{
									ValueDouble = Convert.ToDouble(tagValues[tagIndex]);
									UpdateString.Append(ValueDouble.ToString());
								}
								else if (object.ReferenceEquals(tagValues[tagIndex].GetType(), typeof(int)))
								{
									ValueInteger = Convert.ToInt32(tagValues[tagIndex]);
									UpdateString.Append(ValueInteger.ToString());
								}
								else if (object.ReferenceEquals(tagValues[tagIndex].GetType(), typeof(bool)))
								{
									ValueBoolean = Convert.ToBoolean(tagValues[tagIndex]);
									UpdateString.Append(ValueBoolean.ToString());
								}
								else if (object.ReferenceEquals(tagValues[tagIndex].GetType(), typeof(string)))
								{
									ValueString = tagValues[tagIndex].ToString();
									UpdateString.Append(ValueString);
								}
							}
							catch (Exception ex)
							{
								UpdateString.Append("Error");
							}
						}
						else // The Tag quality is bad
						{
							// Remove the value from the hashtable so you know the value is bad from your own routines
							if (m_DataValuesHashtable.Contains(tagNames[tagIndex]))
							{
								m_DataValuesHashtable.Remove(tagNames[tagIndex]);
							}
							UpdateString.Append("Bad Quality");

						}
						UpdateString.Append("\r" + "\n");
						try
						{
							if (!(m_Closing))
							{
								if (TextBoxValues.Text.Length > (TextBoxValues.MaxLength - 100))
								{
									TextBoxValues.Text = "";
								}
								TextBoxValues.AppendText(UpdateString.ToString());
								UpdateString.Remove(0, UpdateString.Length);
							}
						}
						catch (Exception ex)
						{

						}
					}
				}
			}
			m_InProcessValues = false;
		}

		// You can implement a Hashtable if you simply need to obtain values recieved from your own routines.
		private string GetStringValueFromHashtable(string TagName)
		{
			object Value = null;
			double ValueDouble = 0;
			int ValueInteger = 0;
			bool ValueBoolean = false;
			string ValueString = null;

			lock (m_DataValuesHashtable.SyncRoot)
			{
				if (m_DataValuesHashtable.Contains(TagName))
				{
					Value = m_DataValuesHashtable[TagName];
				}
			}
			if (Value == null)
			{
				return TagName + " has not arrived or is bad quality.";
			}
			else
			{
				if (object.ReferenceEquals(Value.GetType(), typeof(double)))
				{
					ValueDouble = Convert.ToDouble(Value);
					return TagName + " = " + ValueDouble.ToString();
				}
				else if (object.ReferenceEquals(Value.GetType(), typeof(int)))
				{
					ValueInteger = Convert.ToInt32(Value);
					return TagName + " = " + ValueInteger.ToString();
				}
				else if (object.ReferenceEquals(Value.GetType(), typeof(bool)))
				{
					ValueBoolean = Convert.ToBoolean(Value);
					return TagName + " = " + ValueBoolean.ToString();
				}
				else if (object.ReferenceEquals(Value.GetType(), typeof(string)))
				{
					ValueString = Value.ToString();
					return TagName + " = " + ValueString;
				}
			}

			return Value.ToString();
		}

		// SyncReadTags method is a simple call you can use to read any number of Tags with a blocking call.
		// This is a blocking call and should only be called one at a time.
		// The subscription method using AddTags and the ValuesChangedAll event listed above is more efficient for reading Tag values on a continuous basis.
		// This SyncReadTags method does not make a synchronous call to the OPC Servers, it makes a temporary subscription to the OPC Systems Services and receives the current values of the Tags.
		// No features in OPC Systems.NET make synchronous calls to OPC Servers, as it often causes high CPU usage and poor performance.
		private void ButtonSyncRead_Click(object sender, System.EventArgs e)
		{
			string[] Tags = new string[3];
			Tags[0] = "Ramp.Value";
			Tags[1] = "Sine.Value";
			Tags[2] = "Random.Value";
			Int32[] Errors = null;
			// The Errors array will be sized to the same length as your Tags array.
			// The following values will be returned to you in the Int32 array you pass.
			// 0 = Good Quality
			// 1 = Bad Quality
			// 2 = Timeout
			object[] Values = null;
			Values = OpcSystemsData.SyncReadTags(Tags, ref Errors, 10000);
			// The Values array will be sized to the number of Tags you ask for and contain the values if there is Good Quality.
			Int32 TagIndex = 0;
			System.Text.StringBuilder tempStringBuilder = new System.Text.StringBuilder();
			double tempDouble = 0;

			for (TagIndex = 0; TagIndex < Tags.GetLength(0); TagIndex++)
			{
				tempStringBuilder.Append(Tags[TagIndex]);
				tempStringBuilder.Append(" = ");
				switch (Errors[TagIndex])
				{
					case 0:
						tempDouble = Convert.ToDouble(Values[TagIndex]);
						tempStringBuilder.Append(tempDouble.ToString());
						break;
					case 1:
						tempStringBuilder.Append("Bad Quality");
						break;
					case 2:
						tempStringBuilder.Append("Timeout");
						break;
				}
				tempStringBuilder.AppendLine();
			}
			MessageBox.Show(tempStringBuilder.ToString(), "Sync Read Results", MessageBoxButtons.OK, MessageBoxIcon.Information);
		}

		// The ReadOPCItems method is used to perform a DeviceRead to OPC Servers directly to return values.
		// This is a synchronous read to the OPC Systems Service.
		// This is a blocking call and should only be called one at a time.
		// Not as efficient as using the data change events with AddTags method for continuous monitoring.  
		// Returns the OPC Item values.  
		// The Errors array will be set to 0 for success, 1 for bad quality, 2 for timeout response.  
		// The Timeout is in milliseconds.
		private void ButtonReadOPCItems_Click(object sender, System.EventArgs e)
		{
			string[] OPCItems = new string[3];
			OPCItems[0] = "OPCSystems.NET\\Local.Ramp.Value";
			OPCItems[1] = "OPCSystems.NET\\Local.Sine.Value";
			OPCItems[2] = "OPCSystems.NET\\Local.Random.Value";
			// Example reading Kepware OPC Items
			//OPCItems(0) = "Kepware.KEPServerEX.V5\Channel.Device.BooleanOPCItem"
			//OPCItems(1) = "Kepware.KEPServerEX.V5\Channel.Device.FloatOPCItem"
			//OPCItems(2) = "Kepware.KEPServerEX.V5\Channel.Device.StringOPCItem"
			Int32[] Errors = null;
			// The Errors array will be sized to the same length as your OPC Item array.
			// The following values will be returned to you in the Int32 array you pass.
			// 0 = Good Quality
			// 1 = Bad Quality
			// 2 = Timeout
			object[] Values = null;
			// The timeout is the amount of time to wait for the OPC Server to respond with the Device Read of values.  The default is 10 seconds.
			Values = OpcSystemsData.ReadOPCItems(ModuleNetworkNode.NetworkNode, OPCItems, ref Errors, 10000);
			// The Values array will be sized to the number of OPC Items you ask for and contain the values if there is Good Quality.
			Int32 TagIndex = 0;
			System.Text.StringBuilder tempStringBuilder = new System.Text.StringBuilder();
			double tempDouble = 0;

			for (TagIndex = 0; TagIndex < OPCItems.GetLength(0); TagIndex++)
			{
				tempStringBuilder.Append(OPCItems[TagIndex]);
				tempStringBuilder.Append(" = ");
				switch (Errors[TagIndex])
				{
					case 0:
						tempDouble = Convert.ToDouble(Values[TagIndex]);
						tempStringBuilder.Append(tempDouble.ToString());
						break;
					case 1:
						tempStringBuilder.Append("Bad Quality");
						break;
					case 2:
						tempStringBuilder.Append("Timeout");
						break;
				}
				tempStringBuilder.AppendLine();
			}
			MessageBox.Show(tempStringBuilder.ToString(), "Read OPC Items Results", MessageBoxButtons.OK, MessageBoxIcon.Information);
		}


	}

	internal class ClassTagValues
	{
		internal string[] TagNames;
		internal object[] Values;
		internal bool[] Qualities;
		internal DateTime[] TimeStamps;

		public ClassTagValues(string[] NewTagNames, object[] NewValues, bool[] NewQualities, DateTime[] NewTimeStamps)
		{
			TagNames = NewTagNames;
			Values = NewValues;
			Qualities = NewQualities;
			TimeStamps = NewTimeStamps;
		}
	}

}